#ifndef MSP_FS_FILEMONITOR_PLATFORM_H_
#define MSP_FS_FILEMONITOR_PLATFORM_H_

#include <msp/fs/path.h>
#include <msp/io/eventobject.h>
#include "filemonitor.h"

namespace Msp {
namespace FS {

class INotify: public IO::EventObject
{
private:
	IO::Handle fd;

public:
	INotify();
	~INotify();

	int add_watch(const FS::Path &, int);
	void remove_watch(int);

	void set_block(bool) override { }
	void set_inherit(bool) override { }

protected:
	std::size_t do_write(const char *, std::size_t) override;
	std::size_t do_read(char *, std::size_t) override;

public:
	const IO::Handle &get_handle(IO::Mode) override { return fd; }
	const IO::Handle &get_event_handle() override { return fd; }
};


struct FileMonitor::Private
{
	FileMonitor &monitor;
	INotify inotify;

	Private(FileMonitor &);

	void events_available();
};

} // namespace FS
} // namespace Msp

#endif
